/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahl.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahl.entity.WahlParameter;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractWahlParameterSearch {

  @Inject
  protected transient WahlParameterExtendedDAO dao;

  public AbstractWahlParameterSearch() {
    super();
  }

  public List<WahlParameter> getSearchResult(WahlParameterSearchParameters searchParameters, EagerLoadingCollector<WahlParameter> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<WahlParameter> querySearchResult(WahlParameterSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
